{% extends "app/history.html" %}

{% block ancillary_actions %}

    {% load staticfiles %}
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-table.min.css' %}"/>
    {% csrf_token %}
    {% if actor == None %}
        <h3>You have not been mapped to a known Market Actor. Please contact the Marketplace administrator.</h3>
    {% else %}
         {% if request.session.actor.marketActorTypeid.type == "market operator"%}
            <h3>Actions overview</h3>
        {% else %}
            <h3>Previous actions of {{ actor.representativeName }}</h3>
        {% endif %}
        <h3>
            <small>Flexibility</small>
        </h3>

        <table id="ancillary_actions_table"
               data-toggle="table"
               class="table"
               data-pagination="true"
               data-search="true"
               data-page-list="[10, 25, 50, 100, ALL]"
               data-sort-name="date"
               data-sort-order="desc"
               data-click-to-select="true"
               data-single-select="true"
               data-show-export="true">
            <thead>
            <tr>
                 {% if request.session.actor.marketActorTypeid.type == "market operator"%}
                    <th class="th th-inner" data-sortable="true" data-field="participant" data-visible="true">
                        Participant
                    </th>
                {% endif %}


                <th class="th th-inner" data-sortable="true" data-field="id" data-align="center">ID</th>
                <th class="th th-inner" data-sortable="true" data-field="timeframe" data-visible="true">Timeframe</th>
                <th class="th th-inner" data-sortable="true" data-field="marketSession" data-formatter="setMarketSessionFormatter" data-visible="true">Market session</th>
                <th class="th th-inner" data-sortable="true" data-field="service" data-visible="true">Service</th>
                <th class="th th-inner" data-sortable="true" data-field="date" data-align="center">Date</th>
                <th class="th th-inner" data-sortable="true" data-field="actionStartTime" data-align="center">
                    Action<br/>Start Time
                </th>
                <th class="th th-inner" data-sortable="true" data-field="actionEndTime" data-align="center">Action<br>End
                    Time
                </th>
                <th class="th th-inner" data-sortable="true" data-field="value" data-align="center" data-formatter="europeanNumberFormatter">Quantity (kW)</th>
                <th class="th th-inner" data-sortable="true" data-field="price" data-align="center" data-formatter="europeanNumberFormatter">Price</th>
                <th class="th th-inner" data-sortable="true" data-field="actionType" data-align="center"
                    data-formatter="setActionTypeFormatter">Type
                </th>
                <th class="th th-inner" data-sortable="true" data-field="deliveryPoint" data-align="center">Delivery
                    Point
                </th>
                <th class="th th-inner" data-sortable="true" data-field="actionStatus" data-align="center"
                    data-formatter="setActionStatusFormatter">Status
                </th>
                <th class="th th-inner" data-visible="false" data-sortable="true" data-align="center"
                    data-field="amount">Amount
                </th>
            </tr>
            </thead>
        </table>

    {% endif %}
{% endblock %}


{% block scripts %}
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-table.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/moment.min.js' %}"></script>
    <script type="text/javascript"
            src="{% static 'app/scripts/bootstrap-table/extensions/export/bootstrap-table-export.min.js' %}"></script>
    <script type="text/javascript"
            src="{% static 'app/scripts/bootstrap-table/extensions/export/tableExport.js' %}"></script>
    <script type="text/javascript" src="{% static 'gam/scripts/ancillaryHistory.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/date_utils/date_utils.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/utilities.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/admin/displayMarketSessionInfo.js' %}"></script>

    <script type="text/javascript">
        var username = "{{username}}";
        var token = "{{token}}";
        var ANCILLARY_HISTORY_URL = "{{ANCILLARY_HISTORY}}";
        var ACTION_STATUS_URL = "{{ ACTION_STATUS_URL }}";
        var MARKETSESSION_URL = "{{ MARKETSESSION_URL }}";
        var form = "{{ FLEXIBILITY }}";
        var registeredMarket = getUserRegisteredMarketByForm(user_markets, form);
        console.log(registeredMarket.url + ANCILLARY_HISTORY_URL + username + '/');

        var d = [];
        $(document).ready(function () {
            $(".vertical_tab").removeClass("active");
            $(".tab-pane").removeClass("active");
            $("#ancillary_tab").addClass("active");
            $("#ancillary_history").addClass("active");

            $.ajax({
                url: registeredMarket.url + ANCILLARY_HISTORY_URL + username + '/',
                type: 'GET',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", token)
                },
                dataType: 'json',
                success: function (data) {
                    actions = data['actions']
                    clearing_info = data['clearing_info']
                    var c1 = 0;
                    var c2 =0;
                    for (var i in actions) {
                        var clearingPrice;
                        var amount;
                        if ((actions[i].statusid.status != "accepted") && (actions[i].statusid.status != "partially_accepted")) {
                            c1 = c1 +1;
                            clearingPrice = "N/A";
                            amount = "N/A";
                        } else {
                            for (var info in clearing_info) {
                                if (clearing_info[info].id == actions[i].id) {
                                    c2 = c2 + 1;
                                    clearingPrice = parseFloat(clearing_info[info].clearing_price).toFixed(2).toString().replace("." , ",");
                                    amount = parseFloat(clearing_info[info].value).toFixed(3).toString().replace("." , ",") + " " + actions[i].uom;
                                }
                            }
                        }
                        d.push({
                            id: actions[i].id,
                            marketSession: actions[i].marketSessionid.id,
                            participant: actions[i].marketActorid.representativeName,
                            service: getServiceName(actions[i].formid.form),
                            date: moment(actions[i].date).format("YYYY-MM-DD HH:mm +SSSS"),
                            actionStartTime: moment(actions[i].actionStartTime).format("YYYY-MM-DD HH:mm +SSSS"),
                            actionEndTime: moment(actions[i].actionEndTime).format("YYYY-MM-DD HH:mm +SSSS"),
                            value: parseFloat(actions[i].value).toFixed(3).toString(),
                            price: parseFloat(actions[i].price).toFixed(2),
                            actionType: actions[i].actionTypeid.type,
                            deliveryPoint: actions[i].deliveryPoint,
                            actionStatus: actions[i].statusid.id,
                            clearingPrice: clearingPrice,
                            amount: amount,
                            timeframe: actions[i].marketSessionid.marketplaceid.marketServiceTypeid.timeFrameid.type.replace("_", " ")
                        });
                    }
                    var table = $("#ancillary_actions_table").bootstrapTable();
                    {#$("#energy_actions_table").bootstrapTable('destroy');#}
                    $("#ancillary_actions_table").bootstrapTable('load', d);
                    $('.fixed-table-body').css('height', 'auto').css('max-width', '100%');
                }
            });
        });


        function getServiceName(form){

            if(form == "reactive_power_compensation"){
                return "Reactive power compensation";
            } else if(form == "congestion_management"){
                return "Congestion management";
            } else if(form == "spinning_reserve" ){
               return "Spinning reserve";
            } else if(form == "scheduling"){
               return "Scheduling";
            } else{
                return form;
            }

        }

    </script>
{% endblock %}
